/***********************************************************************\

	Product Number: SC-02-5.7

	Version: rev5.7

	Product Name: Spelling Components basic code

	Filename: memory.h


	This document contains private and confidential information and
	its disclosure does not constitute publication.  Some of the
	information herein also may appear in United States and or
	Foreign Patents Pending.  All rights are reserved by Proximity
	Technology Inc., except those specifically granted by license.

\***********************************************************************/

#ifndef SC_MEMORY
#define SC_MEMORY

#define MM_BLKSIZE      1024    /* SC file block size */

/* Priorities of blocks.  A block of lower priority will not replace one 
   with higher priority unless there are no other blocks available.  */ 

#define MM_PR0          0x00    /* Highest priority */
#define MM_PR1          0x01
#define MM_PR2          0x02
#define MM_PR3          0x03

#define MM_PRMASK       0x0F    /* mask to determine a request's priority */
#define MM_WRITE        0x10    /* data will be modified. */
#define MM_READ         0x20    /* read data into memory. */

#endif
