/***********************************************************************\

	Product Number: PROXLIB-01-2.0

	Version: rev2.0

	Product Name: Proximity Subroutine Library

	Filename: language.h


	This document contains private and confidential information and
	its disclosure does not constitute publication.  Some of the
	information herein also may appear in United States and or
	Foreign Patents Pending.  All rights are reserved by Proximity
	Technology Inc., except those specifically granted by license.

\***********************************************************************/

#ifndef _LANGUAGE
#define _LANGUAGE

/* codes for each language */

#define ENGLISH   1             /* American English */
#define GERMAN    2
#define FRENCH    3
#define SPANISH   4
#define ITALIAN   5
#define BRITISH   6             /* British English */
#define SWEDISH   7
#define DANISH    8
#define NORWEGIAN 9
#define DUTCH     10
#define PORTUGUESE 11
#define BRAZILIAN 12            /* Brazilian Portuguese */

#define MAXLANG 12              /* highest language code */

extern int getlang();           /* translates language name to language code*/

#endif /* _LANGUAGE */
